## VGA on the Upduino

Downloaded from https://nobodywasishere.github.io/blog/upduino_vga/

The goal for this project was to develop a GPU-like core in VHDL for the Upduino v2 and v3. This would include a 60Hz 320x200 or 640x480 resolution output with read/write frame and color buffers, using PWM to increase the color depth. The color buffer would utilize color cells similar to those of the Commodore 64. However, due to limitations inherent in the Upduino, the full design was not realized. Instead, a simpler design with a text buffer was built instead.

For a detailed explanation of how this code was created and how it works, please see the blog post listed above.

To make and flash to an Upduino v2 or v3, simply run `make`. You can also use `make warning` and `make error` to pull up the warnings and errors from the previous compile.

- ascii.vhdl - Holds the font for ASCII characters A-Z
- build.log - Log of builds from `make`
- text_buffer.vhdl - Read-only text buffer that holds ASCII values of letters to show on screen
- top.pcf - Pin configuration for Upduino
- top.vhdl - Top VHDL entity which interfaces with the pins and ties the design together
- vga.vhdl - Generates VGA timings and the PLL for the pixel clock, need to adjust when changing resolution or input clock

Device utilization:
```
Number of wires:                315
Number of wire bits:           2745
Number of public wires:         315
Number of public wire bits:    2745
Number of memories:               0
Number of memory bits:            0
Number of processes:              0
Number of cells:               1011

    ICESTORM_LC:   903/ 5280    17%
   ICESTORM_RAM:     0/   30     0%
          SB_IO:     6/   96     6%
          SB_GB:     3/    8    37%
   ICESTORM_PLL:     1/    1   100%
    SB_WARMBOOT:     0/    1     0%
   ICESTORM_DSP:     0/    8     0%
 ICESTORM_HFOSC:     0/    1     0%
 ICESTORM_LFOSC:     0/    1     0%
         SB_I2C:     0/    2     0%
         SB_SPI:     0/    2     0%
         IO_I3C:     0/    2     0%
    SB_LEDDA_IP:     0/    1     0%
    SB_RGBA_DRV:     0/    1     0%
 ICESTORM_SPRAM:     0/    4     0%
```
